SystemOrganization addCategory: #'ChisCommit-Core'!
SystemOrganization addCategory: #'ChisCommit-Core-Tests'!

TestCase subclass: #CHCommitVisualizationTest
	instanceVariableNames: 'stamp commitVisual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHCommitVisualizationTest commentStamp: '<historical>' prior: 0!
A ROCommitVisualizationTest is a test class for testing the behavior of ROCommitVisualization!

!CHCommitVisualizationTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:37'!
setUp

	stamp := CHTimeStamp createFromString: 'AlejandroInfante 1/8/2013 16:52'.
	commitVisual := CHCommitVisualization create: stamp.! !

!CHCommitVisualizationTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 12:09'!
testConstruction

	self assert: (commitVisual model = stamp ).
	self assert: (commitVisual numberOfInteractions = 1 ).
	self assert: (commitVisual numberOfShapes = 2).
	self assert: ((commitVisual getInteraction: ROPopup) text = 'AlejandroInfante 1/8/2013 16:52' ).
	self assert: ((commitVisual shapes at:1) isShapedAs: ROCircle).! !

TestCase subclass: #CHMethodHistoryTest
	instanceVariableNames: 'class selector methodVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

CHMethodHistoryTest class
	instanceVariableNames: 'class selector'!

CHMethodHistoryTest class
	instanceVariableNames: 'class selector'!

!CHMethodHistoryTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:35'!
setUp

	class := Object subclass: #ROVersioningTestClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalVersioning-Core-Tests'.
	
	selector := #myExample.
	class compile:'myExample ^ self'.
	class compile:'myExample ^ self class'.
	class compile:'myExample ^ self'.
	
	methodVersions := CHMethodHistory analyzeSelector: selector in: class.! !

!CHMethodHistoryTest methodsFor: 'running' stamp: 'AlejandroInfante 1/7/2013 18:18'!
tearDown

	class removeFromSystem.! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 10:58'!
testAsString

	self assert: (methodVersions methodDescription = methodVersions asString).! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 15:35'!
testCommitTimeStamps
	
	self assert:  methodVersions commitTimeStamps size = 3.
	
	methodVersions := CHMethodHistory analyzeMethod: (class compiledMethodAt: selector).
	self assert: methodVersions commitTimeStamps size = 3.
	self assert: ((methodVersions commitTimeStamps first) = (class compiledMethodAt: selector)	timeStamp).! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 10:01'!
testMethodDescription

	self assert: (methodVersions methodDescription = selector asString).! !

TestCase subclass: #CHMethodVisualizationTest
	instanceVariableNames: 'methodHist methodVisual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHMethodVisualizationTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/10/2013 16:35'!
setUp

	methodHist := CHMethodHistTest1 new.
	methodVisual := CHMethodVisualization create: methodHist.! !

!CHMethodVisualizationTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:42'!
testConstruction

	self assert: (methodVisual model = methodHist).
	self assert: (methodVisual numberOfShapes = 2 ).
	self assert: (methodVisual numberOfInteractions = 0 ).
	self assert: ((methodVisual shapes at:1) isShapedAs: ROBox).! !

!CHMethodVisualizationTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 10:27'!
testDrawCommits

	|commits normalizer|
	commits := methodHist commitTimeStamps.
	self assert:(methodVisual numberOfElements = 0).
	methodVisual drawCommits: (ROValueLinearNormalizer inContext: (OrderedCollection new add: 1; add: 2; yourself)).
	self assert:(methodVisual numberOfElements = 3).! !

TestCase subclass: #CHTimeRulerTest
	instanceVariableNames: 'normalizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHTimeRulerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 11:18'!
setUp

	normalizer := CHTestUtils getInstance getTestNormalizer.! !

!CHTimeRulerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 18:07'!
testConstruction

	|ruler realPositions testPositions |
	ruler := CH12HourTimeRuler create: normalizer.
	self assert: (ruler beginingDate = '3/2/2013 11:56' ).
	self assert: (ruler endingDate = '3/6/2013 11:56' ).
	self assert: (ruler gap = 12).
	realPositions := ruler marks collect:[:each | each position x].
	testPositions := (0 to: 7 ) collect: [:each |  normalizer roValue: (3539689200 + (each * 12 * 3600))].
	self assert: (realPositions = testPositions asOrderedCollection).
	! !

TestCase subclass: #CHTimeStampTest
	instanceVariableNames: 'parsedStamp method stamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHTimeStampTest commentStamp: '<historical>' prior: 0!
A ROTimeStampTest is a test class for testing the behavior of ROTimeStamp!

!CHTimeStampTest methodsFor: 'initializing' stamp: 'AlejandroInfante 1/8/2013 11:43'!
createMethod
	
	|class selector|
	class := Object subclass: #ROVersioningTestClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalVersioning-Core-Tests'.
	selector := #myExample.
	class compile:'myExample ^ self'.
	class compile:'myExample ^ self class'.
	class compile:'myExample ^ self'.
	
	^ (class compiledMethodAt: selector).	! !

!CHTimeStampTest methodsFor: 'initializing' stamp: 'AlejandroInfante 1/8/2013 12:10'!
createStamp

	^ (VersionsBrowser new 
			scanVersionsOf: method
			class: method methodClass
			meta: method methodClass isMeta 
			category:  method category
			selector: method selector) list first.! !

!CHTimeStampTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:36'!
setUp

	method := self createMethod.
	stamp := self createStamp.
	parsedStamp := CHTimeStamp createFromString: stamp.
	
! !

!CHTimeStampTest methodsFor: 'running' stamp: 'AlejandroInfante 1/8/2013 11:47'!
tearDown
	
	method methodClass removeFromSystem.! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/8/2013 12:32'!
testAsString

	self assert: parsedStamp asString = method timeStamp .! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/8/2013 11:48'!
testAuthor

	self assert: (parsedStamp author = method author ).! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 09:22'!
testDate

	self assert: (parsedStamp date = method timeStamp substrings second asDate ).! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/8/2013 12:30'!
testEquals

	self assert:(parsedStamp = method timeStamp).! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 17:23'!
testTime

	self assert: (parsedStamp time = method timeStamp substrings third asTime ).! !

TestCase subclass: #CHVersionVisualizationTest
	instanceVariableNames: 'visualization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHVersionVisualizationTest commentStamp: '<historical>' prior: 0!
A ROVersionVisualizationTest is a test class for testing the behavior of ROVersionVisualization!

!CHVersionVisualizationTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:37'!
setUp

	visualization := CHVersionVisualization new.! !

!CHVersionVisualizationTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/14/2013 10:35'!
testAddAllMethodHistory

	| collection |
	collection := OrderedCollection new.
	collection add: (CHMethodHistory analyzeSelector: #addMethodHistory: in: CHVersionVisualization).
	collection add: (CHMethodHistory analyzeSelector:#drawCommits in:CHVersionVisualization).

	self assert: visualization methodsHistory size = 0.	
	visualization addAllMethodHistory: collection.
	self assert: visualization methodsHistory size = 2.! !

!CHVersionVisualizationTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 15:37'!
testAddMethodHistory

	| method1 method2 |
	method1 := CHMethodHistory analyzeSelector: #addMethodHistory: in: CHVersionVisualization.
	method2 := CHMethodHistory analyzeSelector:#drawCommits in:CHVersionVisualization.

	self assert: visualization methodsHistory size = 0.	
	visualization addMethodHistory: method1.
	self assert: visualization methodsHistory size = 1.
	visualization addMethodHistory: method2.
	self assert: visualization methodsHistory size = 2.! !

TestCase subclass: #CHVersionsBuilderTest
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHVersionsBuilderTest commentStamp: '<historical>' prior: 0!
A ROVersionsBuilderTest is a test class for testing the behavior of ROVersionsBuilder!

!CHVersionsBuilderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/10/2013 14:26'!
setUp

	builder := CHVersionsBuilder getInstance.! !

!CHVersionsBuilderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/10/2013 16:35'!
testBuildCommitNormalizerOn

	|normalizer methodHist methodVisual methodNormalizer|
	methodNormalizer := ROValueLinearNormalizer inContext: #(3539688960 3540034560).
	methodNormalizer maxScale: 800; minScale: 0.
	methodHist := CHMethodHistTest1 new.
	methodVisual := (CHMethodVisualization create: methodHist) width: 400.
	normalizer := builder buildCommitNormalizer: methodVisual on: methodNormalizer.
	self assert: ( normalizer minScale = 0).
	self assert: ( normalizer maxScale = 400).
	self assert: ( (normalizer roValue: 3540034560 ) = 400).
	self assert: ( (normalizer slope:0 ) = (methodNormalizer slope:0)).! !

!CHVersionsBuilderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/10/2013 12:57'!
testBuildCommitVisualizationWithNormalizer

	|normalizer stamp1 context stamp2 x |
	context := OrderedCollection new.
	stamp1 := CHTimeStamp createFromString: 'AlejandroInfante 3/4/2013 11:56'.
	stamp2 := CHTimeStamp createFromString: 'AlejandroInfante 3/5/2013 11:56'.
	context add: (CHTimeStamp createFromString: 'AlejandroInfante 3/2/2013 11:56').
	context add: (CHTimeStamp createFromString: 'AlejandroInfante 3/6/2013 11:56').
	context add: stamp1.
	normalizer := ROValueLinearNormalizer inContext: 
		(context collect: [:each | each dateAndTime asSeconds]).
	normalizer maxScale: 400; minScale: 0.
	x := (builder buildCommitVisualization: stamp1 withNormalizer: normalizer) positionAsInteger x.
	self assert: ( x = 200).
	
	self assert: ((builder buildCommitVisualization: stamp2 withNormalizer: normalizer)
						positionAsInteger x = 300).! !

!CHVersionsBuilderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/10/2013 17:04'!
testBuildMethodNormalizer

	|collection normalizer |
	collection := OrderedCollection new.
	collection add: CHMethodHistTest1 new; add: CHMethodHistTest2 new.
	normalizer := builder buildMethodNormalizer: collection.
	self assert:((normalizer roValue: 3539861760) = 400).
	self assert:((normalizer roValue: 3539688960) = 0).
	self assert:((normalizer roValue: 3540034560) = 800).! !

!CHVersionsBuilderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 10:15'!
testBuildMethodVisualizationWithNormalizer

	|methodHistory normalizer elem |

	normalizer := builder buildMethodNormalizer: (
		{CHMethodHistTest1 . CHMethodHistTest2} collect: [:each | each new ]
		).
	methodHistory := CHMethodHistTest1 new.
	elem := builder buildMethodVisualization: methodHistory withNormalizer: normalizer.
	self assert: (elem model = methodHistory).
	self assert: (elem width = 425 ).
	self assert: (elem position x = 400).
	self assert: (elem height = 10 ).
	self assert: ((elem shapes at:1) color = Color paleGreen  ).
	! !

ROElement subclass: #CHTimeRuler
	instanceVariableNames: 'marks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

CHTimeRuler subclass: #CHHourTimeRuler
	instanceVariableNames: 'loopIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

CHHourTimeRuler subclass: #CH12HourTimeRuler
	instanceVariableNames: 'labelModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CH12HourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 15:38'!
gap

	^12.! !

!CH12HourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:26'!
initialize

	super initialize.
	labelModel := #( '00:00' '12:00').! !

!CH12HourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:26'!
labelModel

	^labelModel.! !

!CH12HourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 15:37'!
model: normalizer

	super model: normalizer.! !

!CHHourTimeRuler class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 15:01'!
create: normalizer

	|ruler|
	ruler := self new.
	ruler model: normalizer.
	^ruler.! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:54'!
beginingDate

	|date|
	date := DateAndTime fromSeconds: (model minimumValue: 0).
	^ date asDate mmddyyyy, ' ', date asTime hours asString,':',date minutes asString.! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:55'!
endingDate

	|date|
	date := DateAndTime fromSeconds: (model maximumValue: 0).
	^ date asDate mmddyyyy, ' ', date asTime hours asString,':',date minutes asString.! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 09:18'!
initialize

	super initialize.
	loopIndex := 0.! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:26'!
labelModel

	^self subclassResponsibility.! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:46'!
model: normalizer

	super model: normalizer.! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 09:18'!
nextLabel

	|label|
	loopIndex := loopIndex + 1.
	label := self labelModel at: loopIndex.
	loopIndex := loopIndex \\ self labelModel size.
	^label! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:05'!
scale

	^3600.! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 09:29'!
setUpIteration
	
	|date|
	date := DateAndTime fromSeconds: (model minimumValue: 0).
	[date asTime hours > (self gap* loopIndex)] whileTrue: [ loopIndex := loopIndex + 1].
	^3539689200! !

!CHTimeRuler class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:40'!
create: normalizer

	|elem|
	elem := self new.
	elem model: normalizer.
	^elem.! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:47'!
beginingDate

	self subclassResponsibility.! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 09:49'!
drawMarks

	|value|
	value := self setUpIteration.
	[value < (model maximumValue: 0)] whileTrue:[
		|mark label|
		mark := ROLabel elementOn: '|'.
		mark translateTo: ((model roValue: value) @ mark position y).
		marks add: mark.
		label := ROLabel elementOn: self nextLabel.
		ROConstraint stick: label below: mark.
		self add: mark; add: label.
		value := value + (self gap * self scale).
	].! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:55'!
endingDate

	self subclassResponsibility.! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:04'!
gap

	self subclassResponsibility.! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 09:37'!
initialize

	super initialize.
	marks := OrderedCollection new.
! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 18:04'!
marks

	^marks! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 15:42'!
model: normalizer

	super model: normalizer.
	self drawMarks.! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:27'!
nextLabel

	self subclassResponsibility.! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:04'!
scale

	self subclassResponsibility.! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 09:23'!
setUpIteration

	self subclassResponsibility .! !

ROElement subclass: #CHTimeStamp
	instanceVariableNames: 'author date time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHTimeStamp commentStamp: '<historical>' prior: 0!
This class encapsulate a TimeStamp generated by a commit, allowing to retrieve the information easily.!

!CHTimeStamp class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/8/2013 12:00'!
createFromAuthor: author date: date time: time

	^ self new setAuthor: author date: date time: time.! !

!CHTimeStamp class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/8/2013 11:59'!
createFromString: timeStamp

	| parts |
	parts := timeStamp substrings.
	^self createFromAuthor: parts first date: parts second time: parts third.! !

!CHTimeStamp methodsFor: 'comparing' stamp: 'AlejandroInfante 1/8/2013 12:32'!
= aStringOrStamp

	^ aStringOrStamp = self asString.! !

!CHTimeStamp methodsFor: 'converting' stamp: 'AlejandroInfante 1/9/2013 17:49'!
asString
	
	^ self author,' ',self date mmddyyyy,' ', time! !

!CHTimeStamp methodsFor: 'accessors' stamp: 'AlejandroInfante 1/8/2013 12:10'!
author

	^author! !

!CHTimeStamp methodsFor: 'accessors' stamp: 'AlejandroInfante 1/8/2013 12:16'!
date

	^date.! !

!CHTimeStamp methodsFor: 'accessors' stamp: 'AlejandroInfante 1/10/2013 11:59'!
dateAndTime

	^ DateAndTime date: self date time: self time.! !

!CHTimeStamp methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/9/2013 17:49'!
setAuthor: newAuthor date: newDate time: newTime
	
	author:= newAuthor.
	date:= newDate asDate.
	time:= newTime.
	
	^self

	! !

!CHTimeStamp methodsFor: 'accessors' stamp: 'AlejandroInfante 1/9/2013 17:48'!
time

	^time asTime.! !

ROElement subclass: #CHVersionElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHVersionElement commentStamp: '<historical>' prior: 0!
This is an abstract class that is the root of the visual elements displayed by Chisa, this class is a subclass from Roassals -> ROElement.!

CHVersionElement subclass: #CHCommitVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHCommitVisualization commentStamp: '<historical>' prior: 0!
This object is a direct visualization of a commit, once instantiated it has everything it needs to displaying correctly.!

!CHCommitVisualization class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 11:58'!
defaultShape

	^ ROCircle new color: Color blue.! !

!CHCommitVisualization methodsFor: 'accessing' stamp: 'AlejandroInfante 1/9/2013 15:34'!
model: aModel

	super model: aModel.
	self @ (ROPopup text: model asString ).! !

CHVersionElement subclass: #CHMethodVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHMethodVisualization commentStamp: '<historical>' prior: 0!
This object is a direct visualization of a method, once instantiated it has everything it needs to displaying correctly, also is responsible about adding the commits on the visualization.!

!CHMethodVisualization class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:42'!
defaultShape

	^ ROBox new color: Color paleGreen.! !

!CHMethodVisualization methodsFor: 'accessing' stamp: 'AlejandroInfante 1/11/2013 12:29'!
drawCommits: normalizer

	|builder commitNormalizer|
	builder := CHVersionsBuilder getInstance.
	commitNormalizer := builder buildCommitNormalizer: self on: normalizer.
	self addAll: (model commitTimeStamps collect: [:commit | 
			builder buildCommitVisualization: commit withNormalizer: normalizer ]).! !

!CHMethodVisualization methodsFor: 'accessing' stamp: 'AlejandroInfante 1/11/2013 14:46'!
model: aModel

	super model: aModel.
	"self addShape: (ROLabel text: model)"! !

!CHVersionElement class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:46'!
create: model

	^ (self new model: model) addShape: self defaultShape.! !

!CHVersionElement class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 11:16'!
defaultShape

	^ self subclassResponsibility ! !

!CHVersionElement methodsFor: 'accessing' stamp: 'AlejandroInfante 1/9/2013 15:43'!
model: newModel

	super model: newModel.
	self removeInteraction: ROInteraction.
	
	^self.! !

Object subclass: #CHMethodHistory
	instanceVariableNames: 'method list changeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHMethodHistory commentStamp: '<historical>' prior: 0!
This class encapsulate the all the versions of a method.!

CHMethodHistory subclass: #CHMethodHistTest1
	instanceVariableNames: 'classMethodHist'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHMethodHistTest1 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/10/2013 17:30'!
commitTimeStamps
	^ (#('AlejandroInfante 3/5/2013 11:56' 'AlejandroInfante 3/4/2013 23:56' 'AlejandroInfante 3/4/2013 11:56') collect: [:each | CHTimeStamp createFromString: each])asOrderedCollection .! !

!CHMethodHistTest1 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 09:37'!
methodName

	^'TestMethod1'! !

CHMethodHistory subclass: #CHMethodHistTest2
	instanceVariableNames: 'classMethodHist'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHMethodHistTest2 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/11/2013 11:57'!
commitTimeStamps
	^ (#('AlejandroInfante 3/6/2013 11:56' 'AlejandroInfante 3/4/2013 11:56' 'AlejandroInfante 3/2/2013 11:56') collect: [:each | CHTimeStamp createFromString: each]) asOrderedCollection .! !

!CHMethodHistTest2 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 09:37'!
methodName

	^'TestMethod2'! !

!CHMethodHistory class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/8/2013 09:59'!
analyzeMethod:method

	 ^ self new analyzeMethod: method.! !

!CHMethodHistory class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:36'!
analyzeSelector: selector in: class

	^self analyzeMethod: (class compiledMethodAt: selector).! !

!CHMethodHistory methodsFor: 'initializing' stamp: 'AlejandroInfante 1/8/2013 09:59'!
analyzeMethod: newMethod

	method := newMethod.
	self initializeList.
	^self.
	! !

!CHMethodHistory methodsFor: 'converting' stamp: 'AlejandroInfante 1/9/2013 10:59'!
asString

	^ self methodDescription! !

!CHMethodHistory methodsFor: 'accessors' stamp: 'AlejandroInfante 1/11/2013 10:04'!
commitTimeStamps

	^list copy.! !

!CHMethodHistory methodsFor: 'accessors' stamp: 'AlejandroInfante 1/9/2013 18:05'!
firstCommit

	^ self commitTimeStamps last.! !

!CHMethodHistory methodsFor: 'initializing' stamp: 'AlejandroInfante 1/9/2013 15:36'!
initializeList

	|changeSet|
	
	changeSet  := VersionsBrowser new
			scanVersionsOf: method
			class: method methodClass
			meta: method methodClass isMeta 
			category:  method category
			selector: method selector.

	list := changeSet list collect: [:elem | 
		CHTimeStamp createFromString: elem
		].
	changeList := changeSet changeList.! !

!CHMethodHistory methodsFor: 'accessors' stamp: 'AlejandroInfante 1/9/2013 18:06'!
lastCommit

	^ self commitTimeStamps first.! !

!CHMethodHistory methodsFor: 'accessors' stamp: 'AlejandroInfante 1/14/2013 09:34'!
methodDescription

	^self methodName.! !

!CHMethodHistory methodsFor: 'accessors' stamp: 'AlejandroInfante 1/14/2013 09:33'!
methodName

	^method selector asString.! !

Object subclass: #CHTestUtils
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

CHTestUtils class
	instanceVariableNames: 'instance'!

CHTestUtils class
	instanceVariableNames: 'instance'!

!CHTestUtils class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 10:44'!
getInstance

	instance isNil ifTrue:[instance := self new.].
	^instance.! !

!CHTestUtils methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 11:18'!
getTestNormalizer

	| normalizer |
	normalizer := ROValueLinearNormalizer inContext: #(3539688960 3540034560).
	normalizer minScale: 0; maxScale: 800.
	^normalizer.! !

Object subclass: #CHTimeRulerFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHTimeRulerFactory methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 09:42'!
createTimeRuler: methodNormalizer

	|ruler|
	ruler := CH12HourTimeRuler create: methodNormalizer.
	ruler width: 825.
	ruler resizeStrategy: ROFixedSizedParent instance.
	^ruler.! !

Object subclass: #CHVersionVisualization
	instanceVariableNames: 'view rawView elements labels methods methodNormalizer ruler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHVersionVisualization commentStamp: '<historical>' prior: 0!
This class instantiate the Roassal view and is responsible of adding the elements!

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/14/2013 10:30'!
addAllMethodHistory: aCollection

	aCollection do: [:each | self addMethodHistory: each ]! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/10/2013 11:44'!
addMethodHistory: methodHistory

	methods add: methodHistory.! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/14/2013 10:11'!
drawCommits

	elements do: [:each | each drawCommits: methodNormalizer].! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/14/2013 10:04'!
drawLabels

	labels := OrderedCollection new.
	elements do: [:elem |
		|label|
		label := (ROLabel elementOn: elem model methodName).
		ROConstraint stick: label onTheRightOf: elem.
		labels add: label.
		].! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/14/2013 18:08'!
drawMethods

	|builder|
	builder := CHVersionsBuilder getInstance. 
	methodNormalizer := builder buildMethodNormalizer: methods.
	elements := methods collect: [:each | builder buildMethodVisualization: 
		each withNormalizer: methodNormalizer].! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/15/2013 09:40'!
drawRuler

	ruler := CHTimeRulerFactory new createTimeRuler: methodNormalizer.
	elements add: ruler.! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/15/2013 09:56'!
drawRulerWithBorderLabels

	|beginingLabel endingLabel|
	self drawRuler.
	beginingLabel := ROLabel elementOn: ruler beginingDate.
	endingLabel := ROLabel elementOn: ruler endingDate.
	ROConstraint stick: beginingLabel onTheLeftOf: ruler.
	ROConstraint stick: endingLabel onTheRightOf: ruler.
	rawView add: beginingLabel; add: endingLabel.! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/14/2013 09:52'!
initialize

	rawView := ROView new.
	view := ROMondrianViewBuilder view: rawView.
	methods := OrderedCollection new.
	elements := OrderedCollection new.
	labels := OrderedCollection new.! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/15/2013 10:13'!
launch
	
	self drawMethods.
	self drawCommits.
	self drawLabels.
	self drawRulerWithBorderLabels.
	(ROVerticalLineLayout new alignRight gapSize: 1) applyOn: elements.
	
	rawView addAll: elements.
	rawView addAll: labels.
	ROEaselMorphic new populateMenuOn: view.
	view noLayout.
	rawView camera translateBy: -100 @ 0.
	view open.! !

!CHVersionVisualization methodsFor: 'accessors' stamp: 'AlejandroInfante 1/10/2013 11:45'!
methodsHistory

	^methods! !

Object subclass: #CHVersionsBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

CHVersionsBuilder class
	instanceVariableNames: 'instance'!

!CHVersionsBuilder commentStamp: '<historical>' prior: 0!
This is a builder of CHVersionElements for an easy creation of a nice visualization.
!

CHVersionsBuilder class
	instanceVariableNames: 'instance'!

!CHVersionsBuilder class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/8/2013 16:31'!
getInstance

	instance isNil ifTrue:[ instance := self new ].
	^ instance.! !

!CHVersionsBuilder methodsFor: 'builders' stamp: 'AlejandroInfante 1/10/2013 15:37'!
buildCommitNormalizer: methodVisualization on: methodNormalizer

	|normalizer commitTimes|
	commitTimes := methodVisualization model commitTimeStamps asOrderedCollection.
	commitTimes := commitTimes collect: [:each | each dateAndTime asSeconds].
	commitTimes add: (methodNormalizer maximumValue: 0).
	normalizer := ROValueLinearNormalizer inContext: commitTimes.
	normalizer minScale: 0; maxScale: methodVisualization width.
	^normalizer.! !

!CHVersionsBuilder methodsFor: 'builders' stamp: 'AlejandroInfante 1/11/2013 12:16'!
buildCommitVisualization: stamp withNormalizer: normalizer

	|elem|
	elem := CHCommitVisualization create: stamp.
	elem size: 8.
	elem translateTo: (normalizer roValue: stamp dateAndTime asSeconds ) @ elem positionAsInteger y.
	^ elem.! !

!CHVersionsBuilder methodsFor: 'builders' stamp: 'AlejandroInfante 1/11/2013 12:09'!
buildMethodNormalizer: aMethodHistCollection

	|commitCollection normalizer |
	commitCollection := OrderedCollection new.
	aMethodHistCollection do: [:each | commitCollection addAll: each commitTimeStamps].
	commitCollection := commitCollection collect: [:each | each dateAndTime asSeconds].
	normalizer := ROValueLinearNormalizer inContext: commitCollection.
	normalizer minScale: 0; maxScale: 800.
	^normalizer.! !

!CHVersionsBuilder methodsFor: 'builders' stamp: 'AlejandroInfante 1/15/2013 10:15'!
buildMethodVisualization: methodHist withNormalizer: normalizer

	|elem posX |
	elem :=CHMethodVisualization create: methodHist.
	posX := (normalizer roValue: methodHist firstCommit dateAndTime asSeconds).
	elem width: 800 - posX +25.
	elem height: 10.
	elem translateBy: ( posX @ elem position y).
	^elem. ! !

Object subclass: #ChisExample
	instanceVariableNames: 'visual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!ChisExample methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/14/2013 10:06'!
getVisualization

	^visual.! !

!ChisExample methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/15/2013 09:48'!
initialize

	visual := CHVersionVisualization new.
	visual addMethodHistory: (CHMethodHistTest2 new).
	visual addMethodHistory: (CHMethodHistTest1 new ). 
	visual launch.! !
